/*
reinhard@finalmedia.de
Mi 29. Mär 09:08:25 CEST 2023

# charforce c [...]

just write a given line of args to stdout once(!)
and then just clone all incoming lines
from stdin to stdout, but only if line does NOT begin
with the first character of the given args line.

terminates on empty arguments.

example:

charforce o x y

writes a line "o x y" to stdout once(!) and then
just clones all incoming lines from stdin to stdout,
but only if incoming line does NOT begin with "o"

you can use it in this way to force a offset for fbdraw

.. | charforce o 128 128 | fbenv fbdraw

so every fbdraw offset command "o" will get discarded, except
the one you provided: o 128 128


*/

#include <stdio.h>
#include <stdlib.h>
#include <stddef.h>
#include <stdint.h>

int main(int argc, char* argv[])
{
    FILE *fp;
    char *line = NULL;
    size_t len = 0;
    int read;
    int i = 0;

    if (argc<2) { return 1; }

    for (i=1;i<argc;i++) {
	printf("%s",argv[i]);
	if (i<argc-1) { printf(" "); }
	}

    printf("\n");
    fp = fopen("/dev/stdin", "r");
    if (fp == NULL) return 1;
    while ((read = getline(&line, &len, fp)) != -1) {
	if (line[0]!=argv[1][0]) { printf("%s",line); fflush(stdout); }
    }
    free(line);
    fclose(fp);
    return 0;
}

